clear

load spambase.mat %spambase

num_of_k=5;

benchmark = spambase(:,end);

matrix_positive = spambase(benchmark==1,1:end-1);
matrix_negative = spambase(benchmark==0,1:end-1);

%alpha_table = [50:99]/100;
alpha_table = [90:91]/100;

%parpool('local', 4)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% PART I
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

report_alpha_str = cell(size(alpha_table,2),1);
report_alpha_arr = cell(size(alpha_table,2),1);

parfor alphaj=1:size(alpha_table,2)2 %size(alpha_table,2)
    alpha_value = alpha_table(alphaj);

results_str_factor=cell(size(matrix_negative,2),1);
results_arr_factor=cell(size(matrix_negative,2),1);

%for jj=1:size(matrix_negative,2) %for factors    
for jj=1:size(matrix_negative,2) %for factors    
    
    data_1 = [ones(size(matrix_positive,1),1),matrix_positive(:,jj)];
    data_2 = [ones(size(matrix_negative,1),1),matrix_negative(:,jj)];
    
data_all=[];
size_part_1=floor(size(data_1,1)/num_of_k);
size_part_2=floor(size(data_2,1)/num_of_k);

for i=1:num_of_k
   data_all(i).data_1_oos = data_1(1+size_part_1*(i-1):size_part_1*i,:);
   data_all(i).data_2_oos = data_2(1+size_part_2*(i-1):size_part_2*i,:);
end

for i=1:num_of_k
   loc = [];
   for j=1:num_of_k
      if j~=i
          loc = [loc;data_all(j).data_1_oos];
      end
   end
   data_all(i).data_1_in = loc;

   loc = [];
   for j=1:num_of_k
      if j~=i
          loc = [loc;data_all(j).data_2_oos];
      end
   end
   data_all(i).data_2_in = loc;
end

solution_str_cv=cell(num_of_k,1);outargstruc_arr_cv=cell(num_of_k,1);

for lk = 1:num_of_k %for CV
      
   [solution_str,outargstruc_arr] = sub1(data_all(lk).data_1_in,[],...
    data_all(lk).data_2_in,[],data_all(lk).data_1_oos,[],...
    data_all(lk).data_2_oos,[],[[0;1;0],[1;30;0]],[],num2str(alpha_value));
    solution_str_cv{lk}=solution_str;
    outargstruc_arr_cv{lk}=outargstruc_arr;
    
end   
  
 results_str_factor{jj} = solution_str_cv;
 results_arr_factor{jj} = outargstruc_arr_cv;

end

report_alpha_str{alphaj} = results_str_factor;
report_alpha_arr{alphaj} = results_arr_factor;

end %for alphaj=1:2
%parpool close

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Convert the new report with cell array to old report with structure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for alphaj = 1:2
 for jj = 1:size(matrix_negative,2) %for factors    
  for lk = 1:num_of_k %for CV
    results = psg_convert_outargstruc(report_alpha_str{alphaj}{jj}{lk}, report_alpha_arr{alphaj}{jj}{lk});
    outargstruc_arr = results.data;
    solution_str = results.string;
      
    output_structure = tbpsg_solution_struct(solution_str,outargstruc_arr);
     
    scoring_positive_in = output_structure.vector_data.spline_sum_1;
    scoring_negative_in = output_structure.vector_data.spline_sum_2; 
    scoring_positive_oos = output_structure.vector_data.spline_sum_3;
    scoring_negative_oos = output_structure.vector_data.spline_sum_4; 
     
    report_2(alphaj).alpha = alpha_table(alphaj);
    report_2(alphaj).spline_params = [1;30;0];
        
    report_2(alphaj).data(jj).part(lk).scoring_positive_in = scoring_positive_in;
    report_2(alphaj).data(jj).part(lk).scoring_negative_in = scoring_negative_in;
    report_2(alphaj).data(jj).part(lk).scoring_positive_oos = scoring_positive_oos;
    report_2(alphaj).data(jj).part(lk).scoring_negative_oos = scoring_negative_oos;

    report_2(alphaj).data(jj).part(lk).full = output_structure;
      
  end    
 end
end

save report_2_spline_oos_parfor.mat report_2


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% PART II
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load bst_f_all.mat %bst_f_all

load report_2_spline_oos_parfor.mat %report_2

report_alpha_str = cell(size(alpha_table,2),1);
report_alpha_arr = cell(size(alpha_table,2),1);

parfor alphaj=1:size(alpha_table,2) %size(alpha_table,2)

    alpha = report_2(alphaj).alpha;
    
    results_str_factor=cell(1,1); %size(bst_f_all,2)
    results_arr_factor=cell(1,1); %size(bst_f_all,2)
 
 for num_bst_f=1:size(bst_f_all,2)
     solution_str_cv=cell(num_of_k,1);outargstruc_arr_cv=cell(num_of_k,1);
  for lk = 1:num_of_k
     
     data_scoring_positive_in=[];data_scoring_negative_in=[];
     data_scoring_positive_oos=[];data_scoring_negative_oos=[];
     
    for ijj=1:size(bst_f_all(num_bst_f).data,2)
        
        jj = bst_f_all(num_bst_f).data(ijj);
        
        loc1 = report_2(alphaj).data(jj).part(lk).scoring_positive_in;    
        data_scoring_positive_in = [data_scoring_positive_in,loc1];
        
        loc2 = report_2(alphaj).data(jj).part(lk).scoring_negative_in;    
        data_scoring_negative_in = [data_scoring_negative_in,loc2];
        
        loc3 = report_2(alphaj).data(jj).part(lk).scoring_positive_oos;    
        data_scoring_positive_oos = [data_scoring_positive_oos,loc3];
        
        loc4 = report_2(alphaj).data(jj).part(lk).scoring_negative_oos;    
        data_scoring_negative_oos = [data_scoring_negative_oos,loc4];
    end
     
    [solution_str_loc,outargstruc_arr_loc] = sub2(data_scoring_positive_in,[],...
    data_scoring_negative_in,[],data_scoring_positive_oos,[],...
    data_scoring_negative_oos,[],num2str(alpha));


    solution_str_cv{lk}=solution_str_loc;
    outargstruc_arr_cv{lk}=outargstruc_arr_loc;

  end %for lk = 1:num_of_k
    results_str_factor{num_bst_f} = solution_str_cv;
    results_arr_factor{num_bst_f} = outargstruc_arr_cv;
 end %for num_bst_f=1:size(bst_f_all,2)
    report_alpha_str{alphaj} = results_str_factor;
    report_alpha_arr{alphaj} = results_arr_factor;
end %for alphaj=1:1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Convert the new report with cell array to old report with structure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for alphaj = 1:size(alpha_table,2)
 for jj = 1:size(bst_f_all,2) %for factors    
  for lk = 1:num_of_k %for CV
    
    results = psg_convert_outargstruc(report_alpha_str{alphaj}{jj}{lk}, report_alpha_arr{alphaj}{jj}{lk});
    outargstruc_arr = results.data;
    solution_str = results.string;
      
    output_structure = tbpsg_solution_struct(solution_str,outargstruc_arr);
     
    pr_pen_pos_in = output_structure.function_value(2);
    pr_pen_pos_oos = output_structure.function_value(5);
    pr_pen_neg_in = output_structure.function_value(4);
    pr_pen_neg_oos = output_structure.function_value(6);
     
    report_3(alphaj).alpha = alpha_table(alphaj);
    report_3(alphaj).spline_params = [1;30;0];
    report_3(alphaj).factors = bst_f_all(jj).data;
        
    report_3(alphaj).data(jj).part(lk).pr_pen_pos_in = pr_pen_pos_in;
    report_3(alphaj).data(jj).part(lk).pr_pen_pos_oos = pr_pen_pos_oos;
    report_3(alphaj).data(jj).part(lk).pr_pen_neg_in = pr_pen_neg_in;
    report_3(alphaj).data(jj).part(lk).pr_pen_neg_oos = pr_pen_neg_oos;

    report_3(alphaj).data(jj).part(lk).full = output_structure;
      
  end    
 end
end

save report_3_pr_pen_oos_parfor.mat report_3

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% PART III
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load report_3_pr_pen_oos_parfor.mat %report_3

alphaj = 1;
res3=[];
for j=1:size(report_3(alphaj).data,2)
pr_pen_pos_in=[];pr_pen_pos_oos=[];pr_pen_neg_in=[];pr_pen_neg_oos=[];
 for i=1:size(report_3(alphaj).data(j).part,2)
    pr_pen_pos_in = [pr_pen_pos_in,report_3(alphaj).data(j).part(i).pr_pen_pos_in];
    pr_pen_pos_oos = [pr_pen_pos_oos,report_3(alphaj).data(j).part(i).pr_pen_pos_oos];
    pr_pen_neg_in = [pr_pen_neg_in,report_3(alphaj).data(j).part(i).pr_pen_neg_in];
    pr_pen_neg_oos = [pr_pen_neg_oos,report_3(alphaj).data(j).part(i).pr_pen_neg_oos];
 end

res3 = [res3;[mean(pr_pen_pos_in),mean(pr_pen_pos_oos),mean(pr_pen_neg_in),mean(pr_pen_neg_oos)]];
end




















