%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                                                  Class
%matrix_positive_in_data     data        matrix_positive_in     pm_pen(-1, spline_sum(matrix_vars_f1,matrix_positive_in))                      double
%                                                               spline_sum(matrix_vars_f1, matrix_positive_in)
%matrix_positive_in_vars     vars        matrix_positive_in     pm_pen(-1, spline_sum(matrix_vars_f1,matrix_positive_in))                      cell
%                                                               spline_sum(matrix_vars_f1, matrix_positive_in)
%matrix_negative_in_data     data        matrix_negative_in     cvar_risk_g(parameter_alpha, spline_sum(matrix_vars_f1,matrix_negative_in))    double
%                                                               spline_sum(matrix_vars_f1, matrix_negative_in)
%matrix_negative_in_vars     vars        matrix_negative_in     cvar_risk_g(parameter_alpha, spline_sum(matrix_vars_f1,matrix_negative_in))    cell
%                                                               spline_sum(matrix_vars_f1, matrix_negative_in)
%matrix_positive_oos_data    data        matrix_positive_oos    spline_sum(matrix_vars_f1, matrix_positive_oos)                                double
%matrix_positive_oos_vars    vars        matrix_positive_oos    spline_sum(matrix_vars_f1, matrix_positive_oos)                                cell
%matrix_negative_oos_data    data        matrix_negative_oos    spline_sum(matrix_vars_f1, matrix_negative_oos)                                double
%matrix_negative_oos_vars    vars        matrix_negative_oos    spline_sum(matrix_vars_f1, matrix_negative_oos)                                cell
%matrix_vars_f1_data         data        matrix_vars_f1         pm_pen(-1, spline_sum(matrix_vars_f1,matrix_positive_in))                      double
%                                                               cvar_risk_g(parameter_alpha, spline_sum(matrix_vars_f1,matrix_negative_in))
%                                                               spline_sum(matrix_vars_f1, matrix_positive_in)
%                                                               spline_sum(matrix_vars_f1, matrix_negative_in)
%                                                               spline_sum(matrix_vars_f1, matrix_positive_oos)
%                                                               spline_sum(matrix_vars_f1, matrix_negative_oos)
%matrix_vars_f1_vars         vars        matrix_vars_f1         pm_pen(-1, spline_sum(matrix_vars_f1,matrix_positive_in))                      cell
%                                                               cvar_risk_g(parameter_alpha, spline_sum(matrix_vars_f1,matrix_negative_in))
%                                                               spline_sum(matrix_vars_f1, matrix_positive_in)
%                                                               spline_sum(matrix_vars_f1, matrix_negative_in)
%                                                               spline_sum(matrix_vars_f1, matrix_positive_oos)
%                                                               spline_sum(matrix_vars_f1, matrix_negative_oos)
%parameter_alpha_data        data        parameter_alpha        cvar_risk_g(parameter_alpha, spline_sum(matrix_vars_f1,matrix_negative_in))    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = sub1(matrix_positive_in_data,matrix_positive_in_vars,matrix_negative_in_data,matrix_negative_in_vars,matrix_positive_oos_data,matrix_positive_oos_vars,matrix_negative_oos_data,matrix_negative_oos_vars,matrix_vars_f1_data,matrix_vars_f1_vars,parameter_alpha_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_positive_in',matrix_positive_in_data,matrix_positive_in_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_negative_in',matrix_negative_in_data,matrix_negative_in_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_positive_oos',matrix_positive_oos_data,matrix_positive_oos_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_negative_oos',matrix_negative_oos_data,matrix_negative_oos_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_vars_f1',matrix_vars_f1_data,matrix_vars_f1_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  pm_pen(-1, spline_sum(matrix_vars_f1,matrix_positive_in))',...
'constraint: <= 0',...
'  cvar_risk_g(parameter_alpha, spline_sum(matrix_vars_f1,matrix_negative_in))',...
'Solver: VAN',...
'Value:',...
' spline_sum(matrix_vars_f1, matrix_positive_in)',...
' spline_sum(matrix_vars_f1, matrix_negative_in)',...
' spline_sum(matrix_vars_f1, matrix_positive_oos)',...
' spline_sum(matrix_vars_f1, matrix_negative_oos)',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',parameter_alpha_data);

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
%results = psg_convert_outargstruc(solution_str,outargstruc_arr);
%outargstruc_arr = results.data;
%solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

