%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                       PSG Type    PSG Object             Location in Problem Statement                       Class
%data_scoring_positive_in     data        matrix_positive_in     pm_pen(-1, matrix_positive_in)                      double
%                                                                pr_pen_in(0, matrix_positive_in)
%matrix_positive_in_vars      vars        matrix_positive_in     pm_pen(-1, matrix_positive_in)                      cell
%                                                                pr_pen_in(0, matrix_positive_in)
%data_scoring_negative_in     data        matrix_negative_in     cvar_risk_g(parameter_alpha, matrix_negative_in)    double
%                                                                pr_pen_g_in(0,matrix_negative_in)
%matrix_negative_in_vars      vars        matrix_negative_in     cvar_risk_g(parameter_alpha, matrix_negative_in)    cell
%                                                                pr_pen_g_in(0,matrix_negative_in)
%data_scoring_positive_oos    data        matrix_positive_oos    pr_pen_oos(0,matrix_positive_oos)                   double
%matrix_positive_oos_vars     vars        matrix_positive_oos    pr_pen_oos(0,matrix_positive_oos)                   cell
%data_scoring_negative_oos    data        matrix_negative_oos    pr_pen_g_oos(0,matrix_negative_oos)                 double
%matrix_negative_oos_vars     vars        matrix_negative_oos    pr_pen_g_oos(0,matrix_negative_oos)                 cell
%alpha                        data        parameter_alpha        cvar_risk_g(parameter_alpha, matrix_negative_in)    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = sub2(data_scoring_positive_in,matrix_positive_in_vars,data_scoring_negative_in,matrix_negative_in_vars,data_scoring_positive_oos,matrix_positive_oos_vars,data_scoring_negative_oos,matrix_negative_oos_vars,alpha)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_positive_in',data_scoring_positive_in,matrix_positive_in_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_negative_in',data_scoring_negative_in,matrix_negative_in_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_positive_oos',data_scoring_positive_oos,matrix_positive_oos_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_negative_oos',data_scoring_negative_oos,matrix_negative_oos_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  pm_pen(-1, matrix_positive_in)',...
'constraint: <= 0',...
'  cvar_risk_g(parameter_alpha, matrix_negative_in)',...
'Solver: VAN',...
'Value:',...
'pr_pen_in(0, matrix_positive_in)',...
'pr_pen_g_in(0,matrix_negative_in)',...
'pr_pen_oos(0,matrix_positive_oos)',...
'pr_pen_g_oos(0,matrix_negative_oos)',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',alpha);

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
%results = psg_convert_outargstruc(solution_str,outargstruc_arr);
%outargstruc_arr = results.data;
%solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

